DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Date Range Box - Overview

The JavaScript DateRangeBox component allows users to select a date range with ease. The component includes input boxes for start/end dates and a drop-down date picker.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the DateRangeBox features used.
Backend API
$(() => { const msInDay = 1000 * 60 * 60 * 24; const now = new Date(); const initialValue = [ new Date(now.getTime() - msInDay * 3), new Date(now.getTime() + msInDay * 3), ]; $('#range-selection').dxDateRangeBox({ value: initialValue, onValueChanged: showSelectedDays, }); $('#custom-format').dxDateRangeBox({ value: initialValue, displayFormat: 'EEEE, MMM dd', }); $('#apply-value').dxDateRangeBox({ applyValueMode: 'useButtons', }); $('#single-view').dxDateRangeBox({ multiView: false, }); $('#icon-click-only').dxDateRangeBox({ openOnFieldClick: false, }); $('#current-month-only').dxDateRangeBox({ ...getCurrentMonthRange(), }); $('#clear').dxDateRangeBox({ showClearButton: true, value: initialValue, }); $('#disable-out-of-range-selection').dxDateRangeBox({ disableOutOfRangeSelection: true, }); function getCurrentMonthRange() { const lastDay = new Date(now.getFullYear(), now.getMonth() + 1, 0).getDate(); const min = new Date(now.setDate(1)); const max = new Date(now.setDate(lastDay)); return { min, max }; } function showSelectedDays({ value: [startDate, endDate] }) { let daysCount = 0; if (startDate && endDate) { daysCount = (endDate - startDate) / msInDay + 1; } $('#days-selected').text(daysCount); } showSelectedDays({ value: initialValue }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="dx-fieldset"> <div class="dx-field"> <div class="dx-field-label multiline-label"> <span>Default functionality</span> <div class="selected-days-wrapper"> <span>Days selected: </span> <span id="days-selected"></span> </div> </div> <div class="dx-field-value"> <div id="range-selection"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Custom format</div> <div class="dx-field-value"> <div id="custom-format"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Use buttons to apply selection</div> <div class="dx-field-value"> <div id="apply-value"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Single-calendar view</div> <div class="dx-field-value"> <div id="single-view"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Calendar only appears on icon click</div> <div class="dx-field-value"> <div id="icon-click-only"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Limit available dates (this month)</div> <div class="dx-field-value"> <div id="current-month-only"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Disable out of range selection</div> <div class="dx-field-value"> <div id="disable-out-of-range-selection"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Clear button</div> <div class="dx-field-value"> <div id="clear"></div> </div> </div> </div> </div> </body> </html>
.demo-container { height: 690px; } .dx-field { padding: 8px; } .selected-days-wrapper { font-size: 12px; opacity: 0.5; } .multiline-label { padding-top: 0; }

This demo illustrates how to apply the following JavaScript DateRangeBox settings:

  • value An array where you can specify the selected range (start/end dates). The JavaScript DateRangeBox also allows you to define start/end dates separately. For this purpose, use the startDate and endDate properties instead.

  • displayFormat Date display format. You can use one of our predefined formats or specify a custom format as needs dictate. This demo illustrates the latter.

  • disabled
    Specifies whether the JavaScript DateRangeBox responds to user interaction.

  • showClearButton Displays a button that clears JavaScript DateRangeBox values.

  • multiView Switches between our single-month and two-month dropdown calendar.

  • applyValueMode
    Defines whether the selected value is applied instantly or after a user clicks the Apply button.

To get started with the DevExtreme JavaScript DateRangeBox component, refer to the Getting Started with JavaScript DateRangeBox tutorial.

import React, { useCallback, useState } from 'react';
import DateRangeBox from 'devextreme-react/date-range-box';
import type { DateRangeBoxTypes } from 'devextreme-react/date-range-box';
const msInDay = 1000 * 60 * 60 * 24;
const now = new Date();
const lastDay = new Date(now.getFullYear(), now.getMonth() + 1, 0).getDate();
const initialValue: [Date, Date] = [
new Date(now.getTime() - msInDay * 3),
new Date(now.getTime() + msInDay * 3),
];
const min = new Date(now.setDate(1));
const max = new Date(now.setDate(lastDay));
function convertRangeToDays([startDate, endDate]: [Date, Date]): number {
const diffInDay = Math.floor(Math.abs((endDate.valueOf() - startDate.valueOf()) / msInDay));
return diffInDay + 1;
}
export default function App() {
const [selectedDays, setSelectedDays] = useState<number>(convertRangeToDays(initialValue));
const onCurrentValueChange = useCallback(
({ value: [startDate, endDate] }: DateRangeBoxTypes.ValueChangedEvent): void => {
let daysCount = 0;
if (startDate && endDate) {
daysCount = convertRangeToDays([startDate, endDate]);
}
setSelectedDays(daysCount);
},
[],
);
return (
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label multiline-label">
<span>Default functionality</span>
<div className="selected-days-wrapper ">
<span>Days selected: </span>
<span>{selectedDays}</span>
</div>
</div>
<div className="dx-field-value">
<DateRangeBox
defaultValue={initialValue}
onValueChanged={onCurrentValueChange}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Custom format</div>
<div className="dx-field-value">
<DateRangeBox
defaultValue={initialValue}
displayFormat="EEEE, MMM dd"
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Use buttons to apply selection</div>
<div className="dx-field-value">
<DateRangeBox applyValueMode="useButtons" />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Single-calendar view</div>
<div className="dx-field-value">
<DateRangeBox multiView={false} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Calendar only appears on icon click</div>
<div className="dx-field-value">
<DateRangeBox openOnFieldClick={false} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Limit available dates (this month)</div>
<div className="dx-field-value">
<DateRangeBox
min={min}
max={max}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Disable out of range selection</div>
<div className="dx-field-value">
<DateRangeBox disableOutOfRangeSelection={true} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Clear button</div>
<div className="dx-field-value">
<DateRangeBox
defaultValue={initialValue}
showClearButton
/>
</div>
</div>
</div>
);
}
import React, { useCallback, useState } from 'react';
import DateRangeBox from 'devextreme-react/date-range-box';
const msInDay = 1000 * 60 * 60 * 24;
const now = new Date();
const lastDay = new Date(now.getFullYear(), now.getMonth() + 1, 0).getDate();
const initialValue = [new Date(now.getTime() - msInDay * 3), new Date(now.getTime() + msInDay * 3)];
const min = new Date(now.setDate(1));
const max = new Date(now.setDate(lastDay));
function convertRangeToDays([startDate, endDate]) {
const diffInDay = Math.floor(Math.abs((endDate.valueOf() - startDate.valueOf()) / msInDay));
return diffInDay + 1;
}
export default function App() {
const [selectedDays, setSelectedDays] = useState(convertRangeToDays(initialValue));
const onCurrentValueChange = useCallback(({ value: [startDate, endDate] }) => {
let daysCount = 0;
if (startDate && endDate) {
daysCount = convertRangeToDays([startDate, endDate]);
}
setSelectedDays(daysCount);
}, []);
return (
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label multiline-label">
<span>Default functionality</span>
<div className="selected-days-wrapper ">
<span>Days selected: </span>
<span>{selectedDays}</span>
</div>
</div>
<div className="dx-field-value">
<DateRangeBox
defaultValue={initialValue}
onValueChanged={onCurrentValueChange}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Custom format</div>
<div className="dx-field-value">
<DateRangeBox
defaultValue={initialValue}
displayFormat="EEEE, MMM dd"
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Use buttons to apply selection</div>
<div className="dx-field-value">
<DateRangeBox applyValueMode="useButtons" />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Single-calendar view</div>
<div className="dx-field-value">
<DateRangeBox multiView={false} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Calendar only appears on icon click</div>
<div className="dx-field-value">
<DateRangeBox openOnFieldClick={false} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Limit available dates (this month)</div>
<div className="dx-field-value">
<DateRangeBox
min={min}
max={max}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Disable out of range selection</div>
<div className="dx-field-value">
<DateRangeBox disableOutOfRangeSelection={true} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Clear button</div>
<div className="dx-field-value">
<DateRangeBox
defaultValue={initialValue}
showClearButton
/>
</div>
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.demo-container {
height: 690px;
}
.dx-field {
padding: 8px;
}
.selected-days-wrapper {
font-size: 12px;
opacity: 0.5;
}
.multiline-label {
padding-top: 0;
}

<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label multiline-label">
<span>Default functionality</span>
<div class="selected-days-wrapper">
<span>Days selected: </span>
<span>{{ selectedDays }}</span>
</div>
</div>
<div class="dx-field-value">
<dx-date-range-box
[(value)]="currentValue"
(onValueChanged)="currentValueChanged($event)"
>
</dx-date-range-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom format</div>
<div class="dx-field-value">
<dx-date-range-box [value]="initialValue" displayFormat="EEEE, MMM dd">
</dx-date-range-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Use buttons to apply selection</div>
<div class="dx-field-value">
<dx-date-range-box applyValueMode="useButtons"></dx-date-range-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Single-calendar view</div>
<div class="dx-field-value">
<dx-date-range-box [multiView]="false"></dx-date-range-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Calendar only appears on icon click</div>
<div class="dx-field-value">
<dx-date-range-box [openOnFieldClick]="false"></dx-date-range-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Limit available dates (this month)</div>
<div class="dx-field-value">
<dx-date-range-box [min]="min" [max]="max"></dx-date-range-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Disable out of range selection</div>
<div class="dx-field-value">
<dx-date-range-box [disableOutOfRangeSelection]="true">
</dx-date-range-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Clear button</div>
<div class="dx-field-value">
<dx-date-range-box [showClearButton]="true" [value]="initialValue">
</dx-date-range-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxDateRangeBoxModule } from 'devextreme-angular';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
const msInDay = 1000 * 60 * 60 * 24;
const now = new Date();
const initialValue: [Date, Date] = [
new Date(now.getTime() - msInDay * 3),
new Date(now.getTime() + msInDay * 3),
];
function convertRangeToDays([startDate, endDate]) {
const diffInDay = Math.floor(Math.abs((endDate - startDate) / msInDay));
return diffInDay + 1;
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxDateRangeBoxModule,
],
})
export class AppComponent {
currentValue: [Date, Date] = initialValue;
initialValue: [Date, Date] = initialValue;
min: Date = null;
max: Date = null;
selectedDays: number = convertRangeToDays(initialValue);
constructor() {
const lastDay = new Date(now.getFullYear(), now.getMonth() + 1, 0).getDate();
this.min = new Date(now.setDate(1));
this.max = new Date(now.setDate(lastDay));
}
currentValueChanged({ value: [startDate, endDate] }) {
let daysCount = 0;
if (startDate && endDate) {
daysCount = convertRangeToDays([startDate, endDate]);
}
this.selectedDays = daysCount;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .demo-container {
height: 690px;
}
::ng-deep .dx-field {
padding: 8px;
}
::ng-deep .selected-days-wrapper {
font-size: 12px;
color: var(--dx-color-icon);
}
::ng-deep .multiline-label {
padding-top: 0;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label multiline-label">
<span>Default functionality</span>
<div class="selected-days-wrapper ">
<span>Days selected: </span>
<span>{{ selectedDays }}</span>
</div>
</div>
<div class="dx-field-value">
<DxDateRangeBox
v-model:value="currentValue"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom format</div>
<div class="dx-field-value">
<DxDateRangeBox
:value="initialValue"
display-format="EEEE, MMM dd"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Use buttons to apply selection</div>
<div class="dx-field-value">
<DxDateRangeBox
apply-value-mode="useButtons"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Single-calendar view</div>
<div class="dx-field-value">
<DxDateRangeBox
:multi-view="false"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Calendar only appears on icon click</div>
<div class="dx-field-value">
<DxDateRangeBox
:open-on-field-click="false"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Limit available dates (this month)</div>
<div class="dx-field-value">
<DxDateRangeBox
:min="min"
:max="max"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Disable out of range selection</div>
<div class="dx-field-value">
<DxDateRangeBox
:disable-out-of-range-selection="true"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Clear button</div>
<div class="dx-field-value">
<DxDateRangeBox
:show-clear-button="true"
:value="initialValue"
/>
</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { computed, ref } from 'vue';
import DxDateRangeBox from 'devextreme-vue/date-range-box';
const now = new Date();
const msInDay = 1000 * 60 * 60 * 24;
const initialDates = [
new Date(now.getTime() - msInDay * 3),
new Date(now.getTime() + msInDay * 3),
];
const currentValue = ref(initialDates);
const initialValue = initialDates;
const lastDay = new Date(now.getFullYear(), now.getMonth() + 1, 0).getDate();
const min = new Date(now.setDate(1));
const max = new Date(now.setDate(lastDay));
const selectedDays = computed(() => convertRangeToDays(currentValue.value));
function convertRangeToDays([startDate, endDate]: Date[]) {
let daysCount = 0;
if (startDate && endDate) {
daysCount = Math.floor(Math.abs((endDate.getTime() - startDate.getTime()) / msInDay)) + 1;
}
return daysCount;
}
</script>
<style scoped>
.demo-container {
height: 690px;
}
.dx-field {
padding: 8px;
}
.selected-days-wrapper {
font-size: 12px;
color: var(--dx-color-icon);
}
.multiline-label {
padding-top: 0;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'project:utils/demo-vue-loader.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>